// Curry Sokoban Solver
// Copyright 2021 Yaron Shoham

#ifndef __EPISODE
#define __EPISODE

#include "global.h"
#include "moves.h"

typedef struct episode
{
	int box_num;
	int bases[MAX_BOXES];
	int targets[MAX_BOXES];
	int len;
	move moves[MAX_SOL_LEN];
	int has_base[MAX_INNER];
	int has_target[MAX_INNER];
	int player_at_end;
	int seq;
	int difficulty;
} episode;

typedef struct episodes
{
	int episodes_num;
	struct episode *e;
} episodes;


void allocate_episodes(episodes *es, int n);
void free_episodes(episodes *es);

void print_episode(episode *e);
void setup_board_from_episode(board b, episode *e);

void get_suggestion_from_episode(int *b_has_box, int *b_has_target,
	episode *e, move *m, int *value);

int find_easiest_episode(episodes *es);

#endif
