// Curry Sokoban Solver
// Copyright 2021 Yaron Shoham

#ifndef __GLOBAL
#define __GLOBAL

#define WALL 1
#define BOX 2
#define TARGET 4
#define SOKOBAN 8
#define BASE 16


#define SPACE 0

#define MAX_SIZE 51
#define MAX_BOXES 50

#define MAX_SOL_LEN 500

#define OCCUPIED (WALL | BOX)
#define PACKED_BOX (BOX | TARGET)
#define SOKOBAN_ON_TARGET (SOKOBAN | TARGET)

extern int height;
extern int width;

#define MAX_INNER (MAX_SIZE*MAX_SIZE)

#define UINT_64 unsigned long long
#define UINT_16 unsigned short
#define UINT_8 unsigned char


extern int delta_y[4];
extern int delta_x[4];
extern int delta_y_8[8];
extern int delta_x_8[8];

extern int verbose;
extern int level_id;
extern char level_title[1000];

extern int global_initial_player_y, global_initial_player_x;
extern int global_boxes_in_level;

extern char global_dir[1000];
extern char global_level_set_name[1000];

extern int just_one_level;
extern int global_from_level;
extern int global_to_level;

extern int start_time, end_time;
extern int time_limit;
extern char global_fail_reason[50];

extern char solver_name[100];

#endif