// Curry Sokoban Solver
// Copyright 2021 Yaron Shoham

#ifndef __MOVE
#define __MOVE

#include "board.h"

typedef struct move
{
	short from;
	short to;
	char player_position;
} move;

int find_possible_moves(board b, move *moves, int *has_corral);
void apply_move(board b, move *m);

void print_move(move *m);
void get_hashes_of_moves(board b, int moves_num, move *moves, UINT_64 *hashes);

#define MAX_MOVES 11500

extern int current_impossible[MAX_INNER];
extern board current_impossible_board;

#endif